accounts/urls.py
# accounts/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

from . import views
from accounts import views as user_views

app_name = 'account'
urlpatterns = [
    path('signup/', views.SignUp.as_view(), name='signup'),
	path('profile/', user_views.profile, name='profile'),
	path('load_profile_picture/', user_views.loadProfilePicture, name='load_profile_picture'),
]

gestion_projets/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

from .views import *

app_name = 'gestion_projets'
urlpatterns = [
    # Subjects Views
    path('subjects/', login_required(views_subjects.SubjectsView.as_view()), name='subject_list'),
    path('subject/new/', login_required(views_subjects.SubjectNew.as_view()), name='subject_new'),
	path('subject/view/<int:pk>/', login_required(views_subjects.SubjectViewDetailView.as_view()), name='subject_view'),
	path('subject/edit/<int:pk>/', login_required(views_subjects.SubjectEditDetailView.as_view()), name='subject_edit'),
	
    path('subjectFn/<int:subject_id>/', views_subjects.subjectFn, name='subject_Fn'),
    path('subjectFnNew/', views_subjects.subjectFnNew, name='subject_FnNew'),
    
    # Sessions Views
    path('sessions/', login_required(views_sessions.SessionsView.as_view()), name='session_list'),
	path('sessions/view/<int:pk>/', login_required(views_sessions.SessionViewDetailView.as_view()), name='session_view'),

	path('sessions/add_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionAddSubject, name='session_add_subject'),
	path('sessions/remove_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionRemoveSubject, name='session_remove_subject'),
    path('sessions/choose_subject/<int:session_id>/<int:subject_id>', views_sessions.SessionChooseSubject, name='session_choose_subject'),
    
    path('sessions/quit_project/<int:session_id>/<int:project_id>', views_sessions.SessionQuitProject, name='session_quit_project'),
    path('sessions/validate_project/<int:session_id>/<int:project_id>', views_sessions.ProjectValidateTutor, name='project_validate_tutor'),
    path('sessions/validate_project_admin/<int:session_id>/<int:project_id>', views_sessions.ProjectValidateAdmin, name='project_validate_admin'),
    path('sessions/project_remove_student/<int:session_id>/<int:project_id>/<int:user_id>', views_sessions.ProjectRemoveStudent, name='project_remove_student'),
    path('sessions/project_add_student/<int:session_id>/<int:project_id>', views_sessions.ProjectAddStudent, name='project_add_student'),

    path('sessions/create_group_selection/<int:session_id>', views_sessions.CreateGroupSelection, name='create_group_selection'),
    path('sessions/join_group_selection/<int:session_id>/<int:group_id>', views_sessions.JoinGroupSelection, name='join_group_selection'),
    path('sessions/quit_group_selection/<int:session_id>/<int:group_id>', views_sessions.QuitGroupSelection, name='quit_group_selection'),
    path('sessions/save_group_selection/<int:session_id>/<int:group_id>', views_sessions.SaveGroupSelection, name='save_group_selection'),
    path('sessions/create_project_selection/<int:session_id>', views_sessions.CreateProjectSelection, name='create_project_selection'),
    path('sessions/step_project_selection/<int:session_id>', views_sessions.StepProjectSelection, name='step_project_selection'),
    path('sessions/all_step_project_selection/<int:session_id>', views_sessions.AllStepProjectSelection, name='all_step_project_selection'),
    path('sessions/random_ranking_project_selection/<int:session_id>', views_sessions.RandomRankingProjectSelection, name='random_ranking_project_selection'),
    path('sessions/init_order_project_selection/<int:session_id>', views_sessions.InitOrderProjectSelection, name='init_order_project_selection'),

    path('sessions/step_rank_rand_project_selection/<int:session_id>', views_sessions.StepRankRandProjectSelection, name='step_rank_rand_project_selection'),
    path('sessions/all_step_rank_rand_project_selection/<int:session_id>', views_sessions.AllStepRankRandProjectSelection, name='all_step_rank_rand_project_selection'),

    path('sessions/enable_ordering_project_selection/<int:session_id>', views_sessions.EnableOrderingProjectSelection, name='enable_ordering_project_selection'),
    path('sessions/load_ranking_project_selection/<int:session_id>', views_sessions.LoadRankingProjectSelection, name='load_ranking_project_selection'),

    path('sessions/generate_project_project_selection/<int:session_id>', views_sessions.GenerateProjectProjectSelection, name='generate_project_project_selection'),
    path('sessions/delete_project_selection/<int:session_id>/<int:projectsel_id>', views_sessions.DeleteProjectSelection, name='delete_project_selection'),



	path('sessions/new_report/<int:session_id>/<int:project_id>/<int:date_report_id>/', views_sessions.SessionReportNewView, name='session_report_new_view'),
    path('sessions/validate_report_tutor/<int:session_id>/<int:report_id>', views_sessions.ReportValidateTutor, name='report_validate_tutor'),

	path('sessions/new_deposit/<int:session_id>/<int:project_id>/<int:date_deposit_id>/', views_sessions.SessionDepositNewView, name='session_deposit_new_view'),
    path('sessions/validate_deposit_tutor/<int:session_id>/<int:deposit_id>', views_sessions.DepositValidateTutor, name='deposit_validate_tutor'),

	path('sessions/git/<int:session_id>/<int:project_id>/', views_sessions.SessionProjectGitView, name='session_project_git_view'),

    # Sessions Admin Views
    path('sessions/admin/<int:pk>/', login_required(views_sessions_admin.SessionAdminDetailView.as_view()), name='session_admin_view'),
    path('sessions/add_members/<int:session_id>/', views_sessions_admin.SessionAdminAddMembers, name='session_admin_add_members_view'),
    path('sessions/remove_members/<int:session_id>/<int:user_id>', views_sessions_admin.SessionAdminRemoveMembers, name='session_admin_remove_members_view'),
    path('sessions/change_description/<int:session_id>', views_sessions_admin.SessionAdminChangeDescription, name='session_admin_change_description_view'),
    path('sessions/change_phase/<int:session_id>', views_sessions_admin.SessionAdminChangePhase, name='session_admin_change_phase_view'),


    # Project Views
    path('projects/view/<int:pk>/', login_required(views_projects.ProjectViewDetailView.as_view()), name='project_view'),
    path('projects/validate_deposit_tutor/<int:project_id>/<int:deposit_id>', views_projects.DepositValidateTutorProject, name='deposit_validate_project'),
    path('projects/validate_report_tutor/<int:project_id>/<int:report_id>', views_projects.ReportValidateTutorProject, name='report_validate_project'),

    path('projects/testMail/<int:project_id>', views_projects.ReportTestMail, name='report_mail'),

    # Test Views
    path('testOrder/', views_tests.testOrder, name='testOrder')
]

sitePTUT/urls.py
from django.contrib import admin
from django.urls import include, path
from django.views.generic.base import TemplateView
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('gestion_projets/', include('gestion_projets.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('accounts.urls')),
	path('accounts/', include('django.contrib.auth.urls')),
	path('', TemplateView.as_view(template_name='home.html'), name='home'),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

gestion_projets/views/views_projects.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render, redirect
from django.urls import reverse
from django.views import generic
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required

from django.utils import timezone

from ..models import Subject, Session, Project, DateDeposit, Deposit, DateReport, Report, User, ProjectSelection

from datetime import date

from django.core.mail import send_mail

import json



class ProjectViewDetailView(generic.DetailView):
    model = Project
    template_name = 'projects/project_view.html'

    def get_context_data(self, **kwargs):
        # Call the base implementation first to get a context
        context = super().get_context_data(**kwargs)
        user = self.request.user
        # Add in a QuerySet of all the books
        context['session'] = self.object.session
        return context

@login_required
def DepositValidateTutorProject(request, project_id, deposit_id):
    
    if request.user.groups.filter(name='Tutor').exists(): # Vérifie le type d'utilisateur
        project = get_object_or_404(Project, pk=project_id) # Vérifie que le projet existe
        
        if request.user.groups.filter(name=project.session.group): # Vérifie que l'utilisateur à le droit d'accéder à cette session
            if project.session.phase == 3: # Vérifie la phase de la session : Ajout de sujets
                if request.user == project.subject.user or request.user.groups.filter(name='Admin').exists() :# si tuteur du projet ou Admin

                    _deposit = get_object_or_404(Deposit, pk=deposit_id) # Vérifie que le depot existe
                    
                    # Mise à jour du dépôt
                    data = request.POST.copy()
                    _deposit.note = int(data.get('note'))

                    _deposit.is_valid = True
                    _deposit.save()
 
    return HttpResponseRedirect(reverse('gestion_projets:project_view', args=(project_id,)))

@login_required
def ReportValidateTutorProject(request, project_id, report_id):

    if request.user.groups.filter(name='Tutor').exists(): # Vérifie le type d'utilisateur
        project = get_object_or_404(Project, pk=project_id) # Vérifie que le projet existe
        
        if request.user.groups.filter(name=project.session.group): # Vérifie que l'utilisateur à le droit d'accéder à cette session
            if project.session.phase == 3: # Vérifie la phase de la session : Ajout de sujets
                if request.user == project.subject.user or request.user.groups.filter(name='Admin').exists() :# si tuteur du projet ou Admin
                       
                    _report = get_object_or_404(Report, pk=report_id) # Vérifie que le report existe

                    # Mise à jour du rapport
                    data = request.POST.copy()

                    _report.checkbox_contact = data.get('checkbox_contact')=='on'
                    _report.checkbox_task_previous = data.get('checkbox_task_previous')=='on'
                    _report.checkbox_task_next = data.get('checkbox_task_next')=='on'
                    _report.checkbox_members = data.get('checkbox_members')=='on'
                    _report.checkbox_time = data.get('checkbox_time')=='on'
                    _report.comment = data.get('comment')

                    _report.is_valid = True
                    _report.save()
 
    return HttpResponseRedirect(reverse('gestion_projets:project_view', args=(project_id,)))



@login_required
def ReportTestMail(request, project_id):

    if request.user.groups.filter(name='Tutor').exists(): # Vérifie le type d'utilisateur
        project = get_object_or_404(Project, pk=project_id) # Vérifie que le projet existe
        
        if request.user.groups.filter(name=project.session.group): # Vérifie que l'utilisateur à le droit d'accéder à cette session
            if project.session.phase == 3: # Vérifie la phase de la session : Ajout de sujets
                if request.user == project.subject.user or request.user.groups.filter(name='Admin').exists() :# si tuteur du projet ou Admin
                       
                    send_mail(
                        'Mettre le sujet',
                        'Here is the message.',
                        'adrien.peytavie@univ-lyon1.fr',
                        ['adrien.peytavie@liris.cnrs.fr'],
                        fail_silently=False,
                    )
    return HttpResponseRedirect(reverse('gestion_projets:project_view', args=(project_id,)))

gestion_projets/views/views_sessions_admin.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render, redirect
from django.urls import reverse
from django.views import generic
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required

from django.utils import timezone

from ..models import Subject, Session, Project, DateDeposit, Deposit, DateReport, Report, User, ProjectSelection

from datetime import date

from django.core.mail import send_mail

import json


class SessionAdminDetailView(generic.DetailView):
    model = Session
    template_name = 'sessions/session_admin.html'

    def get_context_data(self, **kwargs):
        # Call the base implementation first to get a context
        context = super().get_context_data(**kwargs)
        user = self.request.user
        # Add in a QuerySet of all the books
        context['subject_list'] = Subject.objects.all()
        context['project_user'] = Project.objects.filter(users__id__contains = user.id,session__id__contains = self.object.id)
        context['group_list'] = ProjectSelection.objects.filter(session__id__contains = self.object.id)
        context['projectSelection_user'] = ProjectSelection.objects.filter(users__id__contains = user.id,session__id__contains = self.object.id)
        context['members'] = User.objects.filter(groups__name=self.object.group)
        return context


@login_required
def SessionAdminAddMembers(request, session_id):
    
    if request.user.groups.filter(name='Admin').exists(): # Vérifie le type d'utilisateur
        session = get_object_or_404(Session, pk=session_id) # Vérifie que la session existe
        
        _group = session.group

        if request.method == 'POST': # Vérifie la méthode du formulaire
            list_user_string = request.POST.get('description')

            list_user = list_user_string.splitlines()

            for user in list_user:
                # tester existance avec filter ?
                _user = get_object_or_404(User, username=user) # Récupère l'utilisateur

                _group.user_set.add(_user)

        
    return HttpResponseRedirect(reverse('gestion_projets:session_admin_view', args=(session_id,)))

@login_required
def SessionAdminRemoveMembers(request, session_id, user_id):
    
    if request.user.groups.filter(name='Admin').exists(): # Vérifie le type d'utilisateur
        session = get_object_or_404(Session, pk=session_id) # Vérifie que la session existe
        
        _group = session.group

        _user = get_object_or_404(User, pk=user_id) # Récupère l'utilisateur

        if not (_user.groups.filter(name='Admin').exists()):
            _group.user_set.remove(_user)

    return HttpResponseRedirect(reverse('gestion_projets:session_admin_view', args=(session_id,)))


@login_required
def SessionAdminChangeDescription(request, session_id):
    
    if request.user.groups.filter(name='Admin').exists(): # Vérifie le type d'utilisateur
        session = get_object_or_404(Session, pk=session_id) # Vérifie que la session existe
        
        if request.method == 'POST': # Vérifie la méthode du formulaire
            _description = request.POST.get('description')

            session.description = _description

            session.save()

    return HttpResponseRedirect(reverse('gestion_projets:session_admin_view', args=(session_id,)))


@login_required
def SessionAdminChangePhase(request, session_id):
    
    if request.user.groups.filter(name='Admin').exists(): # Vérifie le type d'utilisateur
        session = get_object_or_404(Session, pk=session_id) # Vérifie que la session existe
        
        if request.method == 'POST': # Vérifie la méthode du formulaire
            _phase = request.POST.get('phase')

            session.phase = _phase

            session.save()

    return HttpResponseRedirect(reverse('gestion_projets:session_admin_view', args=(session_id,)))

gestion_projets/views/views_tests.py
from django.http import HttpResponse, HttpResponseRedirect
from django.shortcuts import get_object_or_404, render, redirect
from django.urls import reverse
from django.views import generic
from django.http import JsonResponse
from django.contrib.auth.decorators import login_required

from django.utils import timezone

from ..models import Subject, Session, Project, DateDeposit, Deposit, DateReport, Report, User, ProjectSelection

from datetime import date

from django.core.mail import send_mail

import json



@login_required
def testOrder(request):# add session id and group
    data = request.POST.copy()
    selection = ProjectSelection.objects.create(order=data.get('order'))
    selection.save()
    # 'text,test'.split(',')

    return HttpResponse(
            json.dumps({"nothing to see": "this isn't happening"}),
            content_type="application/json"
        )
 

gestion_projets/templates/includes/phase1/phase1_Admin.html
<div class="remark primary"><p><b>Explication :</b> En tant qu'administrateur, il n'y a pas grand chose à faire sur cette phase.</p></div>

gestion_projets/templates/includes/phase1/phase1_Student.html
<div class="remark primary">
    <p><b>Explication :</b> Phase de collecte de l'ensemble des sujets. </p>
    <p>Les tuteurs sont actuellement en train de déposer des sujets. Les sujets seront visibles à partir de la phase 2.</p>
</div>
<div class="remark warning">
    <p>Vous n'êtes pas autorisés à déposer des sujets.</p>
</div>

gestion_projets/templates/includes/phase1/phase1_Tutor.html
{% load gestion_projets_extras %}

  
<div class="remark primary"><p><b>Explication :</b> Phase de collecte de l'ensemble des sujets.</p><p> Vous pouvez ajouter n'importe quel sujet de votre liste personnelle ou créer un nouveau sujet.</p></div>
<div class="grid">
    <div class="row p-5">
        <div class="cell-lg-6">
            <!-- Mes sujets / actions -->
            <table class="table">
                <thead>
                <tr>
                    <th>Liste de mes sujets</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
            {% for subject in subject_list %}
                {% if user == subject.user and subject not in session.subjects.all %} 
                    <tr>
                        <td>{{ subject.title }}, {{ subject.user }}</td>
                        <td>
                            
                            <form action="{% url 'gestion_projets:session_add_subject' session.id subject.id %}" method="POST">
                                {% csrf_token %}
                                <a class="image-button success" title="Voir en détail le sujet" target="_blank" href="{% url 'gestion_projets:subject_view' subject.id %}"><center>
                                    <span class="mif-file-text icon"></span>
                                    <span class="caption">Voir</span></center>
                                </a>
                                <button class="image-button warning" title="Ajouter le sujet à la session en cours" type="submit">
                                    <span class="mif-arrow-right icon"></span>
                                    <span class="caption">Ajouter</span>
                                </button>
                            </form>
                        </td>
                    </tr>
                {% endif %}
            {% endfor %}
            </ul>
            </table>
            
            <div class="remark info"><p><b>Explication :</b> Vous pouvez ajouter un sujet parmi votre liste de sujets ou créer un nouveau sujet.</p></div>
            <a class="image-button info" title="Création d'un sujet" href="{% url 'gestion_projets:subject_new' %}"><center>
                <span class="mif-file-text icon"></span>
                <span class="caption">Création d'un sujet</span></center>
            </a>
        </div>
        <div class="cell-lg-6">
            <!-- Liste des sujets -->
            <table class="table">
                <thead>
                <tr>
                    <th>Liste des sujets de la session</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                {% for subject in session.subjects.all %}
                    <tr>
                        <td>{{ subject.title }}, {{ subject.user }}</td>
                        <td> 
                            <form action="{% url 'gestion_projets:session_remove_subject' session.id subject.id %}" method="POST">
                                {% csrf_token %}
                                <a class="image-button success" title="Voir en détail le sujet" target="_blank" href="{% url 'gestion_projets:subject_view' subject.id %}"><center>
                                    <span class="mif-file-text icon"></span>
                                    <span class="caption">Voir</span></center>
                                </a>
                            {% if user == subject.user %}
                                <button class="image-button warning" title="Enlever le sujet de la session" type="submit">
                                    <span class="mif-arrow-left icon"></span>
                                    <span class="caption">Enlever</span>
                                </button>
                            {% endif %}
                            </form>
                        </td>
                    </tr>
                {% endfor %}
                </ul>
                </table>
        </div>
    </div>
</div>